unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Windows;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    Load: TButton;
    Edit1: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit2: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    Edit23: TEdit;
    Edit24: TEdit;
    Edit25: TEdit;
    Edit26: TEdit;
    Edit27: TEdit;
    Edit28: TEdit;
    Edit29: TEdit;
    Edit3: TEdit;
    Edit30: TEdit;
    Edit31: TEdit;
    Edit32: TEdit;
    Edit33: TEdit;
    Edit34: TEdit;
    Edit35: TEdit;
    Edit36: TEdit;
    Edit37: TEdit;
    Edit38: TEdit;
    Edit39: TEdit;
    Edit4: TEdit;
    Edit40: TEdit;
    Edit41: TEdit;
    Edit42: TEdit;
    Edit43: TEdit;
    Edit44: TEdit;
    Edit45: TEdit;
    Edit46: TEdit;
    Edit47: TEdit;
    Edit48: TEdit;
    Edit49: TEdit;
    Edit5: TEdit;
    Edit50: TEdit;
    Edit51: TEdit;
    Edit52: TEdit;
    Edit53: TEdit;
    Edit54: TEdit;
    Edit55: TEdit;
    Edit56: TEdit;
    Edit57: TEdit;
    Edit58: TEdit;
    Edit59: TEdit;
    Edit6: TEdit;
    Edit60: TEdit;
    Edit61: TEdit;
    Edit62: TEdit;
    Edit63: TEdit;
    Edit64: TEdit;
    Edit65: TEdit;
    Edit66: TEdit;
    Edit67: TEdit;
    Edit68: TEdit;
    Edit69: TEdit;
    Edit7: TEdit;
    Edit70: TEdit;
    Edit71: TEdit;
    Edit72: TEdit;
    Edit73: TEdit;
    Edit74: TEdit;
    Edit75: TEdit;
    Edit76: TEdit;
    Edit77: TEdit;
    Edit78: TEdit;
    Edit79: TEdit;
    Edit8: TEdit;
    Edit80: TEdit;
    Edit81: TEdit;
    Edit9: TEdit;
    Save: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    SaveDialog1: TSaveDialog;
    ScrollBar1: TScrollBar;
    Start: TButton;
    OpenDialog1: TOpenDialog;
    Splitter1: TSplitter;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure LoadClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: char);
    procedure FormCreate(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
  private
    { private declarations }
    EditArray: array[1..9,1..9] of TEdit;
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

type
  Tmat = array[1..9,1..9] of string[9];

const   {offset for the location in 9 segment block}
  table1 : array[0..2] of integer = (1,-1,-2);
  table2 : array[0..2] of integer = (2, 1,-1);

var
  CloseFlag : boolean;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
const
  MutexName ='Program open check by Dek';  //a unique string to identify the program

var
  x,y,i: Integer;
  hMutex :THandle;

begin
  Application.Title:='Sudoku solver';
  hMutex :=CreateMutex(nil, False, MutexName); //check if the program already open
  if WaitForSingleObject(hMutex, 0) = WAIT_TIMEOUT then
  begin
    ShowMessage('Program already open');
    halt; // close if open another
  end;

  for y:=1 to 9 do
    for x:=1 to 9 do
    begin
      i := (y-1)*9+(x-1)+1;
      if FindComponent('Edit'+IntToStr(i))<>nil then EditArray[x,y]:= TEdit( FindComponent('Edit'+IntToStr(i)) )
                                                else
      begin
        showmessage('System error!');
        halt;
      end;
      EditArray[x,y].Text:=' ';
    end;
  CloseFlag:=false;
end;

procedure TForm1.SaveClick(Sender: TObject);
  var
  x,y   : integer;
  t     : textfile;
  st    : string;
begin
  if SaveDialog1.Execute then
  begin
    st:=SaveDialog1.FileName;
    if fileexists(st) then
      if Application.MessageBox('Are you sure to overwrite?','Confirmation',MB_YESNO)=IDNO then exit;
    try
      assignfile(t,st);
      rewrite(t);
      for y:=1 to 9 do
      begin
        for x:=1 to 9 do
          write(t,EditArray[x,y].Text);
        writeln(t);
      end;
    except
      showmessage('File access error');
    end;
    closefile(t);
  end;
end;

procedure TForm1.StartClick(Sender: TObject);

function shiftX(x,i: integer): integer;
var
  offset : integer;
begin
  offset:=(x-1) mod 3;
  case i of
    1..8        : if i<x then shiftx:=i
                         else shiftx:=i+1;
    9..16,23,24 : shiftx:=x;
    17,19,21    : shiftx:=x+table1[offset];
    18,20,22    : shiftx:=x+table2[offset];
  end;
end;

function shiftY(y,i: integer): integer;
var
  offset : integer;
begin
  offset:=(y-1) mod 3;
  case i of
    1..8,21,22  : shifty:=y;
    9..16       : if (i-8)<y then shifty:=i-8
                             else shifty:=i-7;
    17,18,23    : shifty:=y+table1[offset];
    19,20,24    : shifty:=y+table2[offset];
  end;
end;

{dislay current status}
procedure disp(mat : Tmat);
var
  x,y     : integer;
begin
  for y:=1 to 9 do
    for x:=1 to 9 do
      if length(mat[x,y])=1 then EditArray[x,y].Text:=mat[x,y]
                            else EditArray[x,y].Text:=' ';
  for x:=1 to ScrollBar1.Position div 10 do
  begin
    Application.ProcessMessages;
    sleep(100);
    if CloseFlag then halt;
  end;
  Application.ProcessMessages;
end;

procedure find(mat:Tmat; var x1,y1:integer); {find minimum number canditate position }
var
  x,y,i : integer;
begin
  i:=10; {number of candidates}
  x1:=0;
  y1:=0;
  for x:=1 to 9 do
    for y:=1 to 9 do
	begin
	  if (length(mat[x,y])>1) and (length(mat[x,y])<i) then
	  begin
	    x1:=x;
	    y1:=y;
	    i:=length(mat[x,y]);
	  end;
	end;
end;

procedure del(var st:string; subst: string);
var
  i     : integer;
begin
  for i:=1 to length(subst) do
    delete(st,pos(subst[i],st),1);
end;

procedure organize(var mat:Tmat);  {eliminate duplicated candidate}
var
  x,y,x1,y1,i : integer;
  st    : string;
  flag  : boolean;
begin
  repeat
    flag:=true;
    for x:=1 to 9 do
      for y:=1 to 9 do
      begin
        if length(mat[x,y])>1 then
        for i:=1 to 20 do
        begin
          x1:=shiftX(x,i);
          y1:=shiftY(y,i);
          if length(mat[x1,y1])=1 then
            if pos(mat[x1,y1],mat[x,y])>0 then
            begin
              delete(mat[x,y],pos(mat[x1,y1],mat[x,y]),1); {eliminate candidate that already existes in another cell}
              flag:=false;
            end;
        end;
      end;
  until flag;
  {addtional try}
  for x:=1 to 9 do
    for y:=1 to 9 do
      if length(mat[x,y])>2 then
      begin
        st:=mat[x,y];
        for i:=1 to 8 do del(st,mat[ShiftX(x,i),ShiftY(y,i)]);
        if length(st)=1 then
        begin
          mat[x,y]:=st;
          break;
        end;
        st:=mat[x,y];
        for i:=9 to 16 do del(st,mat[ShiftX(x,i),ShiftY(y,i)]);
        if length(st)=1 then
        begin
          mat[x,y]:=st;
          break;
        end;
        st:=mat[x,y];
        for i:=17 to 24 do del(st,mat[ShiftX(x,i),ShiftY(y,i)]);
        if length(st)=1 then
        begin
          mat[x,y]:=st;
          break;
        end;
      end;
end;


function solve(var mat_x:Tmat):boolean;   {true=finished/false=not finished}
var
  x,y,x1,y1 : integer;
  mat       : Tmat;
  flag      : boolean;
  st        : string;

begin
  solve:=false;
  mat:=mat_x; {save current status}
  organize(mat); {fill up one possibiliy cells}
  disp(mat);
  flag:=true;
  for y:=1 to 9 do  {check all element fixed?}
    for x:=1 to 9 do
      if length(mat[x,y])<>1 then flag:=false;
  if flag then
  begin
    {Solution found}
    solve:=true;
    exit;
  end;
  find(mat,x1,y1);
  if x1=0 then exit; {return for retry}
  EditArray[x1,y1].Font.Color:=clRed;
  st:=mat[x1,y1];
  repeat
    mat[x1,y1]:=st[1];
    delete(st,1,1);
    disp(mat);
    {recursive call}
    if solve(mat) then { finished? }
    begin
      solve:=true;
      exit;
    end;
    {if got deadlock, Track back}
    EditArray[x1,y1].Font.Color:=clBlack;
    mat:=mat_x; {Restore previous tstus}
    disp(mat);
  until st='';
  EditArray[x1,y1].Font.Color:=clBlack;
end;
{Start button process}
var
  x,y : integer;
  mat : Tmat;
begin
  Start.Enabled:=false;
  Load.Enabled:=false;
  Save.Enabled:=false;
  for y:=1 to 9 do
    for x:=1 to 9 do
      if EditArray[x,y].Text=' ' then mat[x,y]:='123456789'
	                         else mat[x,y]:=EditArray[x,y].Text;
  if solve(mat) then showmessage('A solution found')
                else showmessage('No solution found');
  Start.Enabled:=true;
  Load.Enabled:=true;
  Save.Enabled:=true;
end;

procedure TForm1.LoadClick(Sender: TObject);
var
  x,y   : integer;
  t     : textfile;
  st,msg: string;
begin
  if OpenDialog1.Execute then
  begin
    msg:='File access error';
    try
      assignfile(t,OpenDialog1.FileName);
      reset(t);
      for y:=1 to 9 do
      begin
        readln(t,st);
        if length(st)<>9 then
        begin
          msg:='File format error';
          raise Exception.Create('Dummy');
        end;
        for x:=1 to 9 do
        begin
          if not(st[x] in ['0'..'9',' ']) then
          begin
            msg:='Invalid character in format';
            raise Exception.Create('Dummy');
          end;
          EditArray[x,y].Text:= st[x];
          EditArray[x,y].Font.Color:=clBlack;
        end;
      end;
    except
      showmessage(msg);
      for y:=1 to 9 do
        for x:=1 to 9 do
        begin
          EditArray[x,y].Text:= ' ';
          EditArray[x,y].Font.Color:=clBlack;
        end;
      exit;
    end;
    closefile(t);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  CloseFlag:=true;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: char);
begin
  if key in ['1'..'9',' '] then
  begin
    TEdit(Sender).Text:=key;
    SelectNext(ActiveControl,true,true)
  end;
  key:=#0;
end;

initialization
  {$I unit1.lrs}

end.

